proc vcard:reply {from type body frm ok child} {
global vcard
	if {$ok!="ERR"} {
		wrapper:splitxml $child tag vars isempty chdata children
		putlog "child $child"
		set jid "[user_from_jid $from]/$frm"
		foreach item $children {
			putlog $item
			vcard:parse $item $jid
		}
		
		lappend answer " :"
		if {[info exists vcard(nickname,$jid)]!=0} {
			lappend answer ": $vcard(nickname,$jid)"
		}
		if {[info exists vcard(fn,$jid)]!=0} {
			lappend answer ": $vcard(fn,$jid)"
		} elseif {[info exists vcard(name,$jid)]!=0} {
			lappend answer ": $vcard(name,$jid)"
		}
		if {[info exists vcard(country,$jid)]!=0} {
			lappend answer ": $vcard(country,$jid)"
		}
		if {[info exists vcard(city,$jid)]!=0} {
			lappend answer ": $vcard(city,$jid)"
		}
		if {[info exists vcard(bday,$jid)]!=0} {
			lappend answer " : $vcard(bday,$jid)"
		}
		if {[info exists vcard(desc,$jid)]!=0} {
			lappend answer " : $vcard(desc,$jid)"
		}
		if {[info exists vcard(photo_type,$jid)]!=0} {
			lappend answer "    $vcard(photo_type,$jid)"
		}
		if {$type=="groupchat" } {
			gm "$from" "[join $answer "\n"]"
		} else {
			pm "$from" "[join $answer "\n"]"
		}
	} else {
		if {$type=="groupchat" } {
			gm "$from" ",   "
			putlog "TYPE $type"
		} else {
			pm "$from" ",   "
		}
	}
}

proc wrapper:getattr {varlist attrname} {

  foreach {attr val} $varlist {
   if {$attr == $attrname} {return $val}
  }
  return ""
}



proc vcard:parse {child jid} {
global vcard
    wrapper:splitxml $child tag vars isempty chdata children
   putlog "TAGSSS $tag"
    switch -exact -- $tag { \
   FN       {set vcard(fn,$jid)        $chdata}
   NICKNAME {set vcard(nickname,$jid)     $chdata}
   N        {vcard_parse_n $jid $children}
   PHOTO    {vcard_parse_photo $jid $children}
   ADR      {vcard_parse_adr $jid $children}
   TEL      {vcard_parse_tel $jid $children}
   TEL      {set vcard(telephone,$jid) $chdata}
   EMAIL    {set vcard(email,$jid) $chdata;vcard_parse_email $jid $children}
   JABBERID {set vcard(jabberid,$jid)  $chdata}
   ORG      {vcard_parse_org $jid $children}
   TITLE    {set vcard(title,$jid)     $chdata}
   ROLE     {set vcard(role,$jid)      $chdata}
   BDAY     {
       set vcard(bday,$jid)      $chdata
      putlog $vcard(bday,$jid)
       if {![catch {set bday [clock scan $chdata]}]} {
         set vcard(bdayyear,$jid) [clock format $bday -format %Y]
         set vcard(bdaymonth,$jid) [clock format $bday -format %m]
         set vcard(bdayday,$jid) [clock format $bday -format %d]
       }
   }
   UID      {set vcard(uid,$jid)       $chdata}
   URL      {set vcard(url,$jid)       $chdata}
   DESC     {set vcard(desc,$jid)      $chdata}
   default {putlog "Unknown vCard tag $tag"}
    }
}

proc vcard_parse_email {jid items} {
    global vcard
    foreach item $items {
   wrapper:splitxml $item tag vars isempty chdata children

   switch -- $tag {
       USERID {set vcard(email,$jid) $chdata}
   }
    }
}

proc vcard_parse_n {jid items} {
    global vcard

#    set w [w_from_jid $jid]


    foreach item $items {
   wrapper:splitxml $item tag vars isempty chdata children

   switch -- $tag {
       FAMILY {set vcard(family,$jid) $chdata}
       GIVEN  {set vcard(name,$jid)   $chdata}
       MIDDLE {set vcard(middle,$jid) $chdata}
       default {putlog "Unknown vCard <N/> subtag $tag"}
   }
    }
}

proc vcard_parse_photo {jid items} {
    global vcard

#    set w [w_from_jid $jid]


    foreach item $items {
   wrapper:splitxml $item tag vars isempty chdata children

   switch -- $tag {
       BINVAL {
      #catch {    
      #  set vcard(photo_binval,$jid) [base64::decode $chdata]
      #  set vcard(photo_use,$jid) image
      #  photo_$jid put $chdata
      #  catch { reconfigure_photo $jid }
      #}
       }
       EXTVAL {
      set vcard(photo_extval,$jid) $chdata
      set vcard(photo_use,$jid) url
       }
       TYPE {
      set vcard(photo_type,$jid) $chdata
       }
       default {putlog "Unknown vCard <PHOTO/> subtag $tag"}
   }
    }
}

proc vcard_parse_adr {jid items} {
    global vcard

#    set w [w_from_jid $jid]


    foreach item $items {
   wrapper:splitxml $item tag vars isempty chdata children

   # TODO:
        #  HOME?, 
        #  WORK?, 
        #  POSTAL?, 
        #  PARCEL?, 
        #  (DOM | INTL)?, 
        #  PREF?, 
        #  POBOX?, 
        #  LOCALITY?, 

   switch -- $tag {
       #STREET   {set userinfo(address,$jid)   $chdata}
       LOCALITY {set vcard(city,$jid)   $chdata}
       #REGION   {set userinfo(state,$jid) $chdata}
       #PCODE    {set userinfo(pcode,$jid)   $chdata}
       COUNTRY  {set vcard(country,$jid) $chdata}
       CTRY     {set vcard(country,$jid) $chdata}
       default  {putlog "Unknown vCard <ADR/> subtag $tag"}
   }
    }
}

proc vcard_parse_tel {jid items} {
    global vcard

#    set w [w_from_jid $jid]

    set types {}
    foreach item $items {
   wrapper:splitxml $item tag vars isempty chdata children

   # TODO:
        #  HOME?, 
        #  WORK?, 
        #  VOICE?, 
        #  FAX?, 
        #  PAGER?, 
        #  MSG?, 
        #  CELL?, 
        #  VIDEO?, 
        #  BBS?, 
        #  MODEM?, 
        #  ISDN?, 
        #  PCS?, 
        #  PREF?, 
        #  NUMBER

   switch -- $tag {
       HOME   {lappend types home}
       WORK   {lappend types work}
       VOICE  {lappend types voice}
       FAX    {lappend types fax}
       PAGER  {lappend types pager}
       MSG    {lappend types msg}
       CELL   {lappend types cell}
       VIDEO  {lappend types video}
       BBS    {lappend types bbs}
       MODEM  {lappend types modem}
       ISDN   {lappend types isdn}
       PCS    {lappend types pcs}
       PREF   {lappend types pref}
       NUMBER {
      foreach t $types {
          set vcard(tel_$t,$jid) $chdata
      }
       }
       default {putlog "Unknown vCard <TEL/> subtag $tag"}
   }
    }
}

proc vcard_parse_geo {jid items} {
    variable userinfo

    set w [w_from_jid $jid]


    foreach item $items {
   wrapper:splitxml $item tag vars isempty chdata children

   switch -- $tag {
       LAT {set userinfo(geo_lat,$jid) $chdata}
       LON {set userinfo(geo_lon,$jid)  $chdata}
       default {debugmsg userinfo "Unknown vCard <ORG/> subtag $tag"}
   }
    }
}

proc vcard_parse_org {jid items} {
    global vcard

#    set w [w_from_jid $jid]

    # TODO: <!ELEMENT ORG (ORGNAME, ORGUNIT*)>

    foreach item $items {
   wrapper:splitxml $item tag vars isempty chdata children

   switch -- $tag {
       ORGNAME  {set vcard(orgname,$jid) $chdata}
       ORGUNIT {set vcard(orgunit,$jid)  $chdata}
       default {putlog "Unknown vCard <ORG/> subtag $tag"}
   }
    }
}
