proc version:reply {from type fr ok child} {

	if {$ok!="ERR"} {
		set children $child
		unset child 

		foreach child $children {
			wrapper:splitxml $child ctag cvars cisempty cchdata cchildren
         
			switch -- $ctag {
				name     {set name      $cchdata}
				version  {set version   $cchdata}
				os       {set os     $cchdata}
			}
		}

		if {[info exists name]!=1} {set name " "}
		if {[info exists version]!=1} {set version " "}
		if {[info exists os]!=1} {set os " "}

		if {$type=="groupchat"} {
			if {[resource_from_jid "$from"]=="$fr"} {
				gm "$from" "  $name $version  $os"
			} else {
				gm "$from" "$fr  $name $version  $os"
			}
		} else {
			if {[resource_from_jid "$from"]=="$fr"} {
				pm "$from" "  $name $version  $os"
			} else {
				pm "$from" "$fr  $name $version  $os"
			}
		}
	} else {
		if {$type=="groupchat" } {
			gm "$from" "  .  $fr"
		} else {
			pm "$from" "  .  $fr"
		}
	}
}

proc wrapper:getattr {varlist attrname} {

	foreach {attr val} $varlist {
		if {$attr == $attrname} {return $val}
	}
	return ""
}

proc wrapper:splitxml {xmldata vtag vvars visempty vchdata vchildren} {
	set tag     [lindex $xmldata 0]
	set vars    [lindex $xmldata 1]
	set isempty [lindex $xmldata 2]
	set chdata  [lindex $xmldata 3]
		if { [llength $xmldata] < 5 } {set children ""} else {set children [lrange $xmldata 4 end]}

		uplevel 1 "set [list $vtag]      [list $tag] \n     \
						set [list $vvars]     [list $vars] \n    \
						set [list $visempty]  [list $isempty] \n \
						set [list $vchdata]   [list $chdata] \n  \
						set [list $vchildren] [list $children]"
}
